using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MCL_FreqCounter;

namespace FreqCounterExm
{
    public partial class Form1 : Form
    {

        MCL_FreqCounter.USB_FreqCounter MyCounter = new MCL_FreqCounter.USB_FreqCounter();
        short status;
        float SampleTime;
        double Freq;
        bool StopRun;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            StopRun = false;
            // connect the freq counter by usb
            status = MyCounter.Connect("");
            // in case the connection failed
            if (status <= 0)
            {
                MessageBox.Show("Freq Counter not connected");
                Close();
            }

        }

        private void DelayTime_TextChanged(object sender, EventArgs e)
        {
             float.TryParse(DelayTime.Text,out(SampleTime));
            // change sample time in freq counter box
            status = MyCounter.SetSampleTime(ref(SampleTime));
        }

        private void StartButton_Click(object sender, EventArgs e)
        {

            StopRun = false;
            while (StopRun==false)
            {
                // read new freq from the freq counter
                status = MyCounter.ReadFreq(ref(Freq));
                Frequency.Text = Freq + " MHZ";
                Application.DoEvents();
            }




        }

        private void StopButton_Click(object sender, EventArgs e)
        {
            StopRun = true;
        }

        

       
    }
}