#ifndef _MCLFREQCOUNTER_H
#define _MCLFREQCOUNTER_H

#include <cviauto.h>

#ifdef __cplusplus
    extern "C" {
#endif
extern const IID MCLFreqCounter_IID__USB_FreqCounter;

HRESULT CVIFUNC MCLFreqCounter_New_USB_FreqCounter (const char *server,
                                                    int supportMultithreading,
                                                    LCID locale, int reserved,
                                                    CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLFreqCounter_Open_USB_FreqCounter (const char *fileName,
                                                     const char *server,
                                                     int supportMultithreading,
                                                     LCID locale, int reserved,
                                                     CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLFreqCounter_Active_USB_FreqCounter (const char *server,
                                                       int supportMultithreading,
                                                       LCID locale, int reserved,
                                                       CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterRead_ModelName (CAObjHandle objectHandle,
                                                               ERRORINFO *errorInfo,
                                                               char **modelName,
                                                               short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterSetSampleTime (CAObjHandle objectHandle,
                                                              ERRORINFO *errorInfo,
                                                              float *sampleTime_sec,
                                                              short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterSetRange (CAObjHandle objectHandle,
                                                         ERRORINFO *errorInfo,
                                                         short *requestedRange,
                                                         short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterRead_SN (CAObjHandle objectHandle,
                                                        ERRORINFO *errorInfo,
                                                        char **SN, short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterGet_Available_SN_List (CAObjHandle objectHandle,
                                                                      ERRORINFO *errorInfo,
                                                                      char **SN_List,
                                                                      short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterGetStatus (CAObjHandle objectHandle,
                                                          ERRORINFO *errorInfo,
                                                          short *arg1);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterReadFreq (CAObjHandle objectHandle,
                                                         ERRORINFO *errorInfo,
                                                         double *freqRet,
                                                         short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterGetRange (CAObjHandle objectHandle,
                                                         ERRORINFO *errorInfo,
                                                         char **arg1);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterConnect (CAObjHandle objectHandle,
                                                        ERRORINFO *errorInfo,
                                                        const char *SN_Request,
                                                        short *arg2);

HRESULT CVIFUNC MCLFreqCounter__USB_FreqCounterDisconnect (CAObjHandle objectHandle,
                                                           ERRORINFO *errorInfo);
#ifdef __cplusplus
    }
#endif
#endif /* _MCLFREQCOUNTER_H */
