// FreqCounterExmDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FreqCounterExm.h"
#include "FreqCounterExmDlg.h"

#import "C:\WINDOWS\system32\MCL_FreqCounter.dll"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


using namespace MCL_FreqCounter;


double Freq;
float SampleTime;
int status;



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFreqCounterExmDlg dialog




CFreqCounterExmDlg::CFreqCounterExmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFreqCounterExmDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFreqCounterExmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CFreqCounterExmDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CFreqCounterExmDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CFreqCounterExmDlg::OnBnClickedButton2)
	ON_EN_CHANGE(IDC_EDIT3, &CFreqCounterExmDlg::OnEnChangeEdit3)
END_MESSAGE_MAP()


// CFreqCounterExmDlg message handlers

BOOL CFreqCounterExmDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFreqCounterExmDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFreqCounterExmDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFreqCounterExmDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CFreqCounterExmDlg::OnBnClickedButton1()
{

	HRESULT hresult;
	CLSID clsid;

	CoInitialize(NULL);	//initialize COM library
	hresult=CLSIDFromProgID(OLESTR("MCL_FreqCounter.USB_FreqCounter"), &clsid);


	_USB_FreqCounter *MyCounter;
	hresult=CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_USB_FreqCounterPtr),(LPVOID *) &MyCounter);
	char buf[50];
	status = MyCounter->Connect("");
	if (status <= 0)
	{
		MessageBox(_T("Freq Counter not connected "),MB_OK);
		return;
	}

	CString Sample;
	GetDlgItemText(IDC_EDIT3,Sample);
	

	// convert Sample time from CString to char * 
	// since atof recieve char * as parameter

	int nSize = Sample.GetLength();
	char *tmp = new char[nSize+1];
	memset(tmp,0,nSize+1);
	wcstombs(tmp, Sample, nSize+1);



	SampleTime = (float)atof(tmp);


	// change Sample Time in seconds
	status = MyCounter->SetSampleTime(&SampleTime);
	// Read Freq from Freq counter box
	status = MyCounter->ReadFreq(&Freq);

	sprintf(buf, "%.5f", Freq);
	SetDlgItemText(IDC_EDIT4,CString(buf));




	// TODO: Add your control notification handler code here
}

void CFreqCounterExmDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
}

void CFreqCounterExmDlg::OnEnChangeEdit3()
{
	CString Sample;
	GetDlgItemText(IDC_EDIT3,Sample);
	 char *tmp = (char *)malloc((Sample.GetLength()+1)*sizeof(char *));
	 //const char *tmp = (char *)Sample.GetBuffer();
	tmp[Sample.GetLength()]='\0';
	const char *tmp2 = tmp;
	SampleTime = (float)atof(tmp2);
	
}
